#ifndef _GPIO_H
#define _GPIO_H

#include "stm32f4xx.h"

typedef enum {NORTH_LED,SOUTH_LED,EAST_LED,WEST_LED} led_t;

typedef enum {NORTH_PB,SOUTH_PB,EAST_PB,WEST_PB} pushbutton_t;

void gpio_init(void);
// LED functions
void gpio_set_led(led_t led_id);
void gpio_clear_led(led_t led_id); 
void gpio_toggle_led(led_t led_id); 
void gpio_blink_led(led_t led_id, int16_t period_ms);
// Pushbuttons functions
uint8_t gpio_is_pushbutton_pressed(pushbutton_t pb_id);
void gpio_set_pushbutton_callback(pushbutton_t pb_id,void (*callback)(void));

#endif
