#include "time.h"

static __IO uint32_t timing_delay;

/*******************************************************************************
* Function Name  : SysTickHandler
* Description    : This function handles SysTick Handler.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SysTick_Handler(void)
{
  if(timing_delay!=0)
    timing_delay--;
}

// public functions
void time_init(void)
{
  // set the time base to 1ms
  SysTick_Config(SystemCoreClock / 1000);
  NVIC_SetPriority(SysTick_IRQn,0);
}

void delay_ms(__IO uint32_t time)
{
  timing_delay=time;

  while(timing_delay!=0);
}


